#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin>>n>>q;
    vector <long long> v(n+1);

    for(int i=1; i<=n; i++)
        cin>>v[i];

    while(q--)
    {
        int l, r;
        cin>>l>>r;

        int maxx = 0;
        for(int i=l; i<=r; i++)
        {
            int k = 0;
            for(int j=i; j<=r; j++)
            {
                if((v[i] & v[j]) > (v[i] ^ v[j]))
                    k++;
            }

            maxx = max(maxx, k);
        }

        cout << maxx << "\n";
    }

    return 0;
}